## kexec-tools 1.101

=== Makefile ===
# Hey Emacs this is a -*- makefile-*-
include Makefile.conf
VERSION=1.101
DATE=15 February 2005
PACKAGE=kexec-tools

pkgdatadir = $(datadir)/$(PACKAGE)
pkglibdir = $(libdir)/$(PACKAGE)
pkgincludedir = $(includedir)/$(PACKAGE)

# You can specify DESTDIR on the command line to do a add
# a prefix to the install so it doesn't really happen
# Useful for building binary packages
DESTDIR =

CPPFLAGS:= -I./include -I./util_lib/include \
	-DVERSION='"$(VERSION)"' -DRELEASE_DATE='"$(DATE)"' \
	$(DEFS) $(EXTRA_CFLAGS)

PREFIX:=$(OBJDIR)/build
SBINDIR=$(PREFIX)/sbin
BINDIR=$(PREFIX)/bin
LIBEXECDIR=$(PREFIX)/libexec
DATADIR=$(PREFIX)/share
SYSCONFDIR=$(PREFIX)/etc
SHAREDSTATEDIR=$(PREFIX)/com
LOCALSTATEDIR=$(PREFIX)/var
LIBDIR=$(PREFIX)/lib
INFODIR=$(PREFIX)/info
MANDIR=$(PREFIX)/man
MAN1DIR=$(MANDIR)/man1
MAN2DIR=$(MANDIR)/man2
MAN3DIR=$(MANDIR)/man3
MAN4DIR=$(MANDIR)/man4
MAN5DIR=$(MANDIR)/man5
MAN6DIR=$(MANDIR)/man6
MAN7DIR=$(MANDIR)/man7
MAN8DIR=$(MANDIR)/man8
INCLUDEDIR=$(PREFIX)/include

PKGDATADIR=$(DATADIR)/$(PACKAGE)
PKGLIBDIR=$(LIBDIR)/$(PACKAGE)
PKGINCLUDEIR=$(INCLUDEDIR)/$(PACKAGE)

MAN_PAGES:= kexec/kexec.8
MAN_PAGES+= kdump/kdump.8
BINARIES_i386:=  $(SBINDIR)/kexec $(PKGLIBDIR)/kexec_test
BINARIES_x86_64:=$(SBINDIR)/kexec $(PKGLIBDIR)/kexec_test
BINARIES:=$(SBINDIR)/kexec $(SBINDIR)/kdump $(BINARIES_$(ARCH)) 

TARGETS:=$(BINARIES) $(MAN_PAGES)

all: $(TARGETS)

# cc-option
# Usage: cflags-y += $(call cc-option, -march=winchip-c6, -march=i586)
cc-option = $(shell if $(CC) $(CFLAGS) $(1) -S -o /dev/null -xc /dev/null \
             > /dev/null 2>&1; then echo "$(1)"; else echo "$(2)"; fi ;)

# Utility function library
#
include util_lib/Makefile

#
# Stand alone utilities
#
include util/Makefile

#
# purgatory (code between kernels)
#
include purgatory/Makefile

#
# kexec (linux booting linux)
#
include kexec/Makefile


# kdump (read a crashdump from memory)
#
include kdump/Makefile

#
# kexec_test (test program)
#
ifeq ($(ARCH),i386)
include kexec_test/Makefile
endif
ifeq ($(ARCH),x86_64)
include kexec_test/Makefile
endif

GENERATED_SRCS:= ./configure
SPEC=$(OBJDIR)/$(PACKAGE)-$(VERSION).spec
TARBALL=$(OBJDIR)/$(PACKAGE)-$(VERSION).tar.gz
SRCS:=$(shell $(FIND) \
	./AUTHORS ./COPYING ./News ./TODO \
	./Makefile ./Makefile.conf.in ./configure.ac \
	./kexec-tools.spec.in ./config ./doc \
	./include ./kexec ./purgatory ./kexec_test ./kdump ./util ./util_lib \
	! -path '*CVS*' ! -name '*~' ! -name '.*' \
	-type f -print )
SRCS+=$(GENERATED_SRCS)
PSRCS:=$(patsubst ./%,$(PACKAGE)-$(VERSION)/%,$(SRCS))
PSRCS+=$(PACKAGE)-$(VERSION).spec

Makefile.conf: Makefile.conf.in configure
	/bin/sh ./configure

configure: configure.ac
	autoconf
	$(RM) -rf autom4te.cache

tarball: $(TARBALL)

$(TARBALL): $(SRCS) $(SPEC)
	$(MKDIR) -p $(OBJDIR)
	$(RM) -f $(OBJDIR)/$(PACKAGE)-$(VERSION)
	$(LN) -s .. $(OBJDIR)/$(PACKAGE)-$(VERSION)
	(cd $(OBJDIR); $(TAR) -cf - $(PSRCS) | gzip -9) > $@

rpm: $(TARBALL)
	$(MKDIR) -p $(OBJDIR)/RPM $(OBJDIR)/SRPM $(OBJDIR)/BUILD $(OBJDIR)/SPECS \
		$(OBJDIR)/TMP $(OBJDIR)/SOURCES
	unset MAKEFLAGS MAKELEVEL; \
	$(RPMBUILD) -ta \
		--define '_rpmdir $(OBJDIR)/RPM' \
		--define '_srcrpmdir $(OBJDIR)/SRPM' \
		--define '_builddir $(OBJDIR)/BUILD' \
		--define '_specdir $(OBJDIR)/SPECS' \
		--define '_tmppath $(OBJDIR)/TMP' \
		--define '_sourcedir $(OBJDIR)/SOURCES' \
		$(TARBALL)

$(SPEC): kexec-tools.spec.in Makefile
	$(SED) -e 's,^Version: $$,Version: $(VERSION),' $< > $@

echo::
	@echo ARCH=$(ARCH)
	@echo BINARIES=$(BINARIES)
	@echo TARGETS=$(TARGETS)
	@echo CC=$(CC)
	@echo AR=$(AR)
	@echo LD=$(LD)

clean:
	@$(FIND) $(OBJDIR) ! -name '*.d' -type f | $(XARGS) $(RM) rm -f
	@$(RM) -rf rpm
	@$(RM) -f config.log config.status config.cache
	@$(RM) -f $(TARBALL)

dist-clean: clean
	@$(RM) -rf $(OBJDIR)
	@$(FIND) . -type f -name '*~' -o -name '*.orig' | $(XARGS) $(RM) -f
	@$(RM) -f Makefile.conf

maintainer-clean: dist-clean
	@$(RM) -f $(GENERATED_SRCS)


install: $(TARGETS)
	for file in $(TARGETS) ; do \
		if test `$(DIRNAME) $$file` =     "$(SBINDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(sbindir)/; \
			$(INSTALL) -m 555  $$file $(DESTDIR)/$(sbindir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(BINDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(bindir)/; \
			$(INSTALL) -m 555 $$file $(DESTDIR)/$(bindir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(LIBEXECDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(libexecdir)/; \
			$(INSTALL) -m 555 $$file $(DESTDIR)/$(libexecdir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(DATADIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(datadir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(datadir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(SYSCONFDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(sysconfdir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(sysconfdir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(SHAREDSTATEDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(sharedstatedir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(sharedstatedir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(LOCALSTATEDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(localstatedir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(localstatedir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(LIBDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(libdir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(libdir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(INFODIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(infodir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(infodir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN1DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man1; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man1; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN2DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man2; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man2; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN3DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man3/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man3/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN4DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man4/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man4/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN5DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man5/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man5/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN6DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man6/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man6/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN7DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man7/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man7/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(MAN8DIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(mandir)/man8/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(mandir)/man8/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(INCLUDEDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(includedir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(includedir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(PKGDATADIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(pkgdatadir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(pkgdatadir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(PKGLIBDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(pkglibdir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(pkglibdir)/; \
		fi; \
		if test `$(DIRNAME) $$file` =     "$(PKGINCLUDEDIR)" ; then \
			$(MKDIR) -p     $(DESTDIR)/$(pkgincludedir)/; \
			$(INSTALL) -m 444 $$file $(DESTDIR)/$(pkgincludedir)/; \
		fi; \
	done

.PHONY: echo install all clean dist-clean maintainer-clean tarball rpm

=== kdump/Makefile ===
#
# kdump (reading a crashdump from memory)
#

KDUMP_C_SRCS:= kdump/kdump.c

KDUMP_C_OBJS:= $(patsubst %.c, $(OBJDIR)/%.o, $(KDUMP_C_SRCS))
KDUMP_C_DEPS:= $(patsubst %.c, $(OBJDIR)/%.d, $(KDUMP_C_SRCS))
KDUMP_SRCS:= $(KDUMP_C_SRCS)
KDUMP_OBJS:= $(KDUMP_C_OBJS)
KDUMP_DEPS:= $(KDUMP_C_DEPS)
KDUMP:= $(SBINDIR)/kdump
KDUMP_MANPAGE:= $(MANDIR)/man8/kdump.8

include $(KDUMP_DEPS)

$(KDUMP_C_DEPS): $(OBJDIR)/%.d: %.c
	mkdir -p $(@D)
	$(CC) $(CFLAGS) -M $< | sed -e 's|$(patsubst %.d,%.o,$(@F))|$(patsubst %.d,%.o,$(@))|' > $@

$(KDUMP_C_OBJS): $(OBJDIR)/%.o: %.c $(OBJDIR)/%.d
	mkdir -p $(@D)
	$(CC) $(CFLAGS) -o $@ -c $<

$(KDUMP): $(KDUMP_OBJS)
	mkdir -p $(@D)
	$(CC) $(CFLAGS) -o $@ $(KDUMP_OBJS)

$(KDUMP_MANPAGE): kdump/kdump.8
	$(MKDIR) -p     $(MANDIR)/man8
	cp kdump/kdump.8 $(KDUMP_MANPAGE)
echo::
	@echo "KDUMP_C_SRCS $(KDUMP_C_SRCS)"
	@echo "KDUMP_C_DEPS $(KDUMP_C_DEPS)"
	@echo "KDUMP_C_OBJS $(KDUMP_C_OBJS)"
	@echo "KDUMP_SRCS $(KDUMP_SRCS)"
	@echo "KDUMP_DEPS $(KDUMP_DEPS)"
	@echo "KDUMP_OBJS $(KDUMP_OBJS)"

=== kexec/Makefile ===
#
# kexec (linux booting linux)
#
PURGATORY_HEX_C:= $(OBJDIR)/kexec/purgatory.c

$(PURGATORY_HEX_C): $(PURGATORY) $(BIN_TO_HEX)
	$(MKDIR) -p $(@D)
	$(BIN_TO_HEX) purgatory < $(PURGATORY) > $@

KCFLAGS:= $(CFLAGS) -Ikexec/arch/$(ARCH)/include

KEXEC_C_SRCS:= kexec/kexec.c 
KEXEC_C_SRCS+= kexec/ifdown.c
KEXEC_C_SRCS+= kexec/kexec-elf.c 
KEXEC_C_SRCS+= kexec/kexec-elf-exec.c 
KEXEC_C_SRCS+= kexec/kexec-elf-rel.c 
KEXEC_C_SRCS+= kexec/kexec-elf-boot.c 
KEXEC_C_SRCS+= kexec/crashdump.c
KEXEC_C_SRCS+= $(PURGATORY_HEX_C)
KEXEC_S_SRCS:= 
include kexec/arch/$(ARCH)/Makefile

KEXEC_C_OBJS:= $(patsubst %.c, $(OBJDIR)/%.o, $(KEXEC_C_SRCS))
KEXEC_C_DEPS:= $(patsubst %.c, $(OBJDIR)/%.d, $(KEXEC_C_SRCS))
KEXEC_S_OBJS:= $(patsubst %.S, $(OBJDIR)/%.o, $(KEXEC_S_SRCS))
KEXEC_S_DEPS:= $(patsubst %.S, $(OBJDIR)/%.d, $(KEXEC_S_SRCS))
KEXEC_SRCS:= $(KEXEC_C_SRCS) $(KEXEC_S_SRCS)
KEXEC_OBJS:= $(KEXEC_C_OBJS) $(KEXEC_S_OBJS)
KEXEC_DEPS:= $(KEXEC_C_DEPS) $(KEXEC_S_DEPS)
KEXEC:= $(SBINDIR)/kexec
KEXEC_MANPAGE:= $(MANDIR)/man8/kexec.8

include $(KEXEC_DEPS)

$(KEXEC_C_DEPS): $(OBJDIR)/%.d: %.c
	mkdir -p $(@D)
	$(CC) $(KCFLAGS) -M $< | sed -e 's|$(patsubst %.d,%.o,$(@F))|$(patsubst %.d,%.o,$(@))|' > $@

$(KEXEC_S_DEPS): $(OBJDIR)/%.d: %.S
	mkdir -p $(@D)
	$(CC) $(KCFLAGS) -M $< | sed -e 's|$(patsubst %.d,%.o,$(@F))|$(patsubst %.d,%.o,$(@))|' > $@

$(KEXEC_C_OBJS): $(OBJDIR)/%.o: %.c $(OBJDIR)/%.d
	mkdir -p $(@D)
	$(CC) $(KCFLAGS) -o $@ -c $<

$(KEXEC_S_OBJS): $(OBJDIR)/%.o: %.S $(OBJDIR)/%.d
	mkdir -p $(@D)
	$(CC) $(KCFLAGS) -o $@ -c $<

$(KEXEC): $(KEXEC_OBJS) $(UTIL_LIB)
	mkdir -p $(@D)
	$(CC) $(KCFLAGS) -o $@ $(KEXEC_OBJS) $(UTIL_LIB) $(LIBS)

$(KEXEC_MANPAGE): kexec/kexec.8
	 $(MKDIR) -p     $(MANDIR)/man8
	cp kexec/kexec.8 $(KEXEC_MANPAGE)
echo::
	@echo "KEXEC_C_SRCS $(KEXEC_C_SRCS)"
	@echo "KEXEC_C_DEPS $(KEXEC_C_DEPS)"
	@echo "KEXEC_C_OBJS $(KEXEC_C_OBJS)"
	@echo "KEXEC_S_SRCS $(KEXEC_S_SRCS)"
	@echo "KEXEC_S_DEPS $(KEXEC_S_DEPS)"
	@echo "KEXEC_S_OBJS $(KEXEC_S_OBJS)"
	@echo "KEXEC_SRCS $(KEXEC_SRCS)"
	@echo "KEXEC_DEPS $(KEXEC_DEPS)"
	@echo "KEXEC_OBJS $(KEXEC_OBJS)"

=== kexec_test/Makefile ===
#
# kexec_test Debugging payload to be certain the infrastructure works
#
RELOC:=0x10000
KEXEC_TEST_S_SRCS:= kexec_test/kexec_test16.S kexec_test/kexec_test.S
KEXEC_TEST_S_TEMPS:=$(patsubst %.S, $(OBJDIR)/%.s, $(KEXEC_TEST_S_SRCS))
KEXEC_TEST_S_OBJS:=$(patsubst $(OBJDIR)/%.s, $(OBJDIR)/%.o, $(KEXEC_TEST_S_TEMPS))
KEXEC_TEST_S_DEPS:=$(patsubst %.S, $(OBJDIR)/%.d, $(KEXEC_TEST_S_SRCS))
KEXEC_TEST_SRCS:= $(KEXEC_TEST_S_SRCS)
KEXEC_TEST_OBJS:= $(KEXEC_TEST_S_OBJS)
KEXEC_TEST_DEPS:= $(KEXEC_TEST_S_DEPS)
KEXEC_TEST:=$(PKGLIBDIR)/kexec_test

include $(KEXEC_TEST_DEPS)

$(KEXEC_TEST_S_DEPS): $(OBJDIR)/%.d: %.S
	mkdir -p $(@D)
	$(CC) -m32 $(CFLAGS) -M $< | sed -e 's|$(patsubst %.d,%.o,$(@F))|$(patsubst %.d,%.o,$(@))|' > $@

$(KEXEC_TEST_S_TEMPS): $(OBJDIR)/%.s: %.S 
	mkdir -p $(@D)
	$(CPP) $(CPPFLAGS) -DRELOC=$(RELOC) $< > $@

$(KEXEC_TEST_S_OBJS): $(OBJDIR)/%.o: $(OBJDIR)/%.s 
	mkdir -p $(@D)
	$(AS) --32 -o $@ $<

$(KEXEC_TEST): $(KEXEC_TEST_OBJS) 
	mkdir -p $(@D)
	$(LD) -m elf_i386 -e _start -Ttext $(RELOC) $(KEXEC_TEST_OBJS) -o $@

=== purgatory/Makefile ===
#
# Purgatory (an uncomfortable intermediate state)
#            In this case the code that runs between kernels
#

# There is probably a cleaner way to do this but for now this
# should keep us from accidentially include unsafe library functions
# or headers.

ifeq ($(ARCH),ppc64)
LDFLAGS = -melf64ppc
endif

PCFLAGS:=-Wall -Os  \
	-I$(shell $(CC) -print-file-name=include) \
	-Ipurgatory/include -Ipurgatory/arch/$(ARCH)/include \
	$(CPPFLAGS)

PCFLAGS += $(call cc-option, -ffreestanding)
PCFLAGS += $(call cc-option, -fnobuiltin)
PCFLAGS += $(call cc-option, -fnostdinc)
PCFLAGS += $(call cc-option, -fno-zero-initialized-in-bss)

PURGATORY_C_SRCS:=
PURGATORY_C_SRCS += purgatory/purgatory.c
PURGATORY_C_SRCS += purgatory/printf.c
PURGATORY_C_SRCS += purgatory/string.c
PURGATORY_S_OBJS:=

include purgatory/arch/$(ARCH)/Makefile


PURGATORY_C_OBJS:= $(patsubst %.c, $(OBJDIR)/%.o, $(PURGATORY_C_SRCS))
PURGATORY_C_DEPS:= $(patsubst %.c, $(OBJDIR)/%.d, $(PURGATORY_C_SRCS))
PURGATORY_S_OBJS:= $(patsubst %.S, $(OBJDIR)/%.o, $(PURGATORY_S_SRCS))
PURGATORY_S_DEPS:= $(patsubst %.S, $(OBJDIR)/%.d, $(PURGATORY_S_SRCS))
PURGATORY_SRCS:= $(PURGATORY_S_SRCS) $(PURGATORY_C_SRCS)
PURGATORY_OBJS:= $(PURGATORY_S_OBJS) $(PURGATORY_C_OBJS)
PURGATORY_DEPS:= $(PURGATORY_S_DEPS) $(PURGATORY_C_DEPS)
PURGATORY:= $(OBJDIR)/purgatory/purgatory.ro

include $(PURGATORY_DEPS)

$(PURGATORY_C_DEPS): $(OBJDIR)/%.d: %.c
	$(MKDIR) -p $(@D)
	$(CC) $(PCFLAGS) -M $< | sed -e 's|$(patsubst %.d,%.o,$(@F))|$(patsubst %.d,%.o,$(@))|' > $@

$(PURGATORY_S_DEPS): $(OBJDIR)/%.d: %.S
	$(MKDIR) -p $(@D)
	$(CC) $(PCFLAGS) -M $< | sed -e 's|$(patsubst %.d,%.o,$(@F))|$(patsubst %.d,%.o,$(@))|' > $@

$(PURGATORY_C_OBJS): $(OBJDIR)/%.o: %.c $(OBJDIR)/%.d
	$(MKDIR) -p $(@D)
	$(CC) $(PCFLAGS) -o $@ -c $<

$(PURGATORY_S_OBJS): $(OBJDIR)/%.o: %.S $(OBJDIR)/%.d
	$(MKDIR) -p $(@D)
	$(CC) $(PCFLAGS) -o $@ -c $<

$(PURGATORY): $(PURGATORY_OBJS) $(UTIL_LIB)
	$(MKDIR) -p $(@D)
	$(LD) $(LDFLAGS) --no-undefined -e purgatory_start -r -o $@ $(PURGATORY_OBJS) $(UTIL_LIB)

echo::
	@echo "PURGATORY_C_SRCS $(PURGATORY_C_SRCS)"
	@echo "PURGATORY_C_DEPS $(PURGATORY_C_DEPS)"
	@echo "PURGATORY_C_OBJS $(PURGATORY_C_OBJS)"
	@echo "PURGATORY_S_SRCS $(PURGATORY_S_SRCS)"
	@echo "PURGATORY_S_DEPS $(PURGATORY_S_DEPS)"
	@echo "PURGATORY_S_OBJS $(PURGATORY_S_OBJS)"
	@echo "PURGATORY_SRCS   $(PURGATORY_SRCS)"
	@echo "PURGATORY_DEPS   $(PURGATORY_DEPS)"
	@echo "PURGATORY_OBJS   $(PURGATORY_OBJS)"

=== util_lib/Makefile ===
#
# Utility function library
#
UTIL_LIB_SRCS:=util_lib/compute_ip_checksum.c
UTIL_LIB_SRCS+=util_lib/sha256.c
UTIL_LIB_OBJS:=$(patsubst %.c, $(OBJDIR)/%.o, $(UTIL_LIB_SRCS))
UTIL_LIB_DEPS:=$(patsubst %.c, $(OBJDIR)/%.d, $(UTIL_LIB_SRCS))
UTIL_LIB:=$(OBJDIR)/libutil.a

include $(UTIL_LIB_DEPS)

$(UTIL_LIB_DEPS): $(OBJDIR)/%.d: %.c 
	$(MKDIR) -p $(@D)
	$(CC) $(CFLAGS) -M $< | sed -e 's|$(patsubst %.d,%.o,$(@F))|$(patsubst %.d,%.o,$(@))|' > $@

$(UTIL_LIB_OBJS): $(OBJDIR)/%.o: %.c $(OBJDIR)/%.d
	$(MKDIR) -p $(@D)
	$(CC) $(CFLAGS) -c -o $@ $<

$(UTIL_LIB): $(UTIL_LIB_OBJS)
	$(MKDIR) -p $(@D)
	$(AR) rs $(UTIL_LIB) $(UTIL_LIB_OBJS)

=== kexec/arch/i386/Makefile ===
#
# kexec i386 (linux booting linux)
#
KEXEC_C_SRCS+= kexec/arch/i386/kexec-x86.c 
KEXEC_C_SRCS+= kexec/arch/i386/kexec-elf-x86.c 
KEXEC_C_SRCS+= kexec/arch/i386/kexec-elf-rel-x86.c
KEXEC_C_SRCS+= kexec/arch/i386/kexec-bzImage.c 
KEXEC_C_SRCS+= kexec/arch/i386/kexec-multiboot-x86.c
KEXEC_C_SRCS+= kexec/arch/i386/kexec-beoboot-x86.c
KEXEC_C_SRCS+= kexec/arch/i386/kexec-nbi.c
KEXEC_C_SRCS+= kexec/arch/i386/x86-linux-setup.c
KEXEC_C_SRCS+= kexec/arch/i386/crashdump-x86.c

=== kexec/arch/ia64/Makefile ===
#
# kexec ia64 (linux booting linux)
#
KEXEC_C_SRCS+= kexec/arch/ia64/kexec-ia64.c 
KEXEC_C_SRCS+= kexec/arch/ia64/kexec-elf-ia64.c 
KEXEC_C_SRCS+= kexec/arch/ia64/kexec-elf-rel-ia64.c

=== kexec/arch/ppc64/Makefile ===
#
# kexec ppc64 (linux booting linux)
#
KEXEC_C_SRCS+= kexec/arch/ppc64/kexec-elf-rel-ppc64.c
KEXEC_C_SRCS+= kexec/arch/ppc64/kexec-zImage-ppc64.c 

KEXEC_S_SRCS+=

=== kexec/arch/x86_64/Makefile ===
#
# kexec x86_64 (linux booting linux)
#
KEXEC_C_SRCS+= kexec/arch/i386/kexec-elf-x86.c 
KEXEC_C_SRCS+= kexec/arch/i386/kexec-bzImage.c 
KEXEC_C_SRCS+= kexec/arch/i386/kexec-multiboot-x86.c
KEXEC_C_SRCS+= kexec/arch/i386/kexec-beoboot-x86.c
KEXEC_C_SRCS+= kexec/arch/i386/kexec-nbi.c
KEXEC_C_SRCS+= kexec/arch/i386/x86-linux-setup.c
KEXEC_C_SRCS+= kexec/arch/x86_64/crashdump-x86_64.c
KEXEC_C_SRCS+= kexec/arch/x86_64/kexec-x86_64.c 
KEXEC_C_SRCS+= kexec/arch/x86_64/kexec-elf-x86_64.c 
KEXEC_C_SRCS+= kexec/arch/x86_64/kexec-elf-rel-x86_64.c

=== purgatory/arch/i386/Makefile ===
#
# Purgatory i386
#

PURGATORY_S_SRCS+= purgatory/arch/i386/entry32-16.S
PURGATORY_S_SRCS+= purgatory/arch/i386/entry32-16-debug.S
PURGATORY_S_SRCS+= purgatory/arch/i386/entry32.S
PURGATORY_S_SRCS+= purgatory/arch/i386/setup-x86.S
PURGATORY_S_SRCS+= purgatory/arch/i386/stack.S
PURGATORY_S_SRCS+= purgatory/arch/i386/compat_x86_64.S
PURGATORY_C_SRCS+= purgatory/arch/i386/purgatory-x86.c
PURGATORY_C_SRCS+= purgatory/arch/i386/console-x86.c
PURGATORY_C_SRCS+= purgatory/arch/i386/vga.c
PURGATORY_C_SRCS+= purgatory/arch/i386/pic.c

=== purgatory/arch/ia64/Makefile ===
#
# Purgatory ia64
#

PURGATORY_S_SRCS+=
PURGATORY_C_SRCS+= purgatory/arch/ia64/purgatory-ia64.c
PURGATORY_C_SRCS+= purgatory/arch/ia64/console-ia64.c
PURGATORY_C_SRCS+=

## kexec-tools 2.0.1

=== kexec/Makefile ===
#
# kexec (linux booting linux)
#
PURGATORY_HEX_C = kexec/purgatory.c

$(PURGATORY_HEX_C): $(PURGATORY) $(BIN_TO_HEX)
	$(MKDIR) -p $(@D)
	$(BIN_TO_HEX) purgatory < $(PURGATORY) > $@

KEXEC_SRCS =
KEXEC_GENERATED_SRCS =

KEXEC_SRCS += kexec/kexec.c
KEXEC_SRCS += kexec/ifdown.c
KEXEC_SRCS += kexec/kexec-elf.c
KEXEC_SRCS += kexec/kexec-elf-exec.c
KEXEC_SRCS += kexec/kexec-elf-core.c
KEXEC_SRCS += kexec/kexec-elf-rel.c
KEXEC_SRCS += kexec/kexec-elf-boot.c
KEXEC_SRCS += kexec/kexec-iomem.c
KEXEC_SRCS += kexec/firmware_memmap.c
KEXEC_SRCS += kexec/crashdump.c
KEXEC_SRCS += kexec/crashdump-xen.c
KEXEC_SRCS += kexec/phys_arch.c

KEXEC_GENERATED_SRCS += $(PURGATORY_HEX_C)

dist += kexec/Makefile $(KEXEC_SRCS) $(KEXEC_GENERATED_SRCS)	\
	kexec/crashdump-elf.c					\
	kexec/crashdump.h kexec/firmware_memmap.h		\
	kexec/kexec-elf-boot.h					\
	kexec/kexec-elf.h kexec/kexec-sha256.h			\
	kexec/kexec-syscall.h kexec/kexec.h kexec/kexec.8

$(ARCH)_PROC_IOMEM		= kexec/proc_iomem.c
KEXEC_SRCS += $($(ARCH)_PROC_IOMEM)
$(ARCH)_VIRT_TO_PHYS		= kexec/virt_to_phys.c
KEXEC_SRCS += $($(ARCH)_VIRT_TO_PHYS)
$(ARCH)_ADD_SEGMENT		= kexec/add_segment.c
KEXEC_SRCS += $($(ARCH)_ADD_SEGMENT)
$(ARCH)_ADD_BUFFER		= kexec/add_buffer.c
KEXEC_SRCS += $($(ARCH)_ADD_BUFFER)
$(ARCH)_ARCH_REUSE_INITRD	= kexec/arch_reuse_initrd.c
KEXEC_SRCS += $($(ARCH)_ARCH_REUSE_INITRD)

include $(srcdir)/kexec/arch/alpha/Makefile
include $(srcdir)/kexec/arch/arm/Makefile
include $(srcdir)/kexec/arch/i386/Makefile
include $(srcdir)/kexec/arch/ia64/Makefile
include $(srcdir)/kexec/arch/mips/Makefile
include $(srcdir)/kexec/arch/cris/Makefile
include $(srcdir)/kexec/arch/ppc/Makefile
include $(srcdir)/kexec/arch/ppc64/Makefile
include $(srcdir)/kexec/arch/s390/Makefile
include $(srcdir)/kexec/arch/sh/Makefile
include $(srcdir)/kexec/arch/x86_64/Makefile

KEXEC_SRCS += $($(ARCH)_KEXEC_SRCS)

KEXEC_OBJS = $(call objify, $(KEXEC_SRCS) $(KEXEC_GENERATED_SRCS))
KEXEC_DEPS = $(call depify, $(KEXEC_OBJS))

clean += $(KEXEC_OBJS) $(KEXEC_DEPS) $(KEXEC_GENERATED_SRCS) \
	 $(KEXEC) $(KEXEC_MANPAGE)

KEXEC = $(SBINDIR)/kexec
KEXEC_MANPAGE = $(MANDIR)/man8/kexec.8

-include $(KEXEC_DEPS)

$(KEXEC): $(KEXEC_OBJS) $(UTIL_LIB)
	@$(MKDIR) -p $(@D)
	$(LINK.o) -o $@ $^ $(LIBS)

$(KEXEC): CPPFLAGS+=-I$(srcdir)/kexec/arch/$(ARCH)/include

$(KEXEC_MANPAGE): kexec/kexec.8
	@$(MKDIR) -p     $(MANDIR)/man8
	cp kexec/kexec.8 $(KEXEC_MANPAGE)
echo::
	@echo "KEXEC_SRCS $(KEXEC_SRCS)"
	@echo "KEXEC_DEPS $(KEXEC_DEPS)"
	@echo "KEXEC_OBJS $(KEXEC_OBJS)"

=== kexec/arch/mips/Makefile ===
#
# kexec mips (linux booting linux)
#
mips_KEXEC_SRCS =  kexec/arch/mips/kexec-mips.c
mips_KEXEC_SRCS += kexec/arch/mips/kexec-elf-mips.c
mips_KEXEC_SRCS += kexec/arch/mips/kexec-elf-rel-mips.c
mips_KEXEC_SRCS += kexec/arch/mips/mips-setup-simple.S

mips_ADD_BUFFER =
mips_ADD_SEGMENT =
mips_VIRT_TO_PHYS =

dist += kexec/arch/mips/Makefile $(mips_KEXEC_SRCS)			\
	kexec/arch/mips/kexec-mips.h					\
	kexec/arch/mips/include/arch/options.h

=== purgatory/arch/s390/Makefile ===
#
# Purgatory s390
#

s390_PURGATORY_SRCS =

dist += purgatory/arch/s390/Makefile $(s390_PURGATORY_SRCS)

## kexec-tools 2.0.1-1ubuntu2-1drbl

=== debian/changelog ===
kexec-tools (1:2.0.1-1ubuntu2-1drbl) lucid; urgency=low

  * Ignore the grub config error, since on debootstrap or live cd, there is no grub available.

 -- Steven Shiau <steven@nchc.org.tw>  Fri, 18 Feb 2010 22:40:00 +0800

kexec-tools (1:2.0.1-1ubuntu2) lucid; urgency=low

  * Don't call db_stop in the postinst; this is not what it's for, and it
    causes update-grub to break on Ubuntu by killing the frontend that child
    processes expect to talk to.  LP: #518853.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 17 Feb 2010 23:04:30 -0800

kexec-tools (1:2.0.1-1ubuntu1) lucid; urgency=low

  * Merge from Debian; replace arm-getpagesize-unistd and configure_syntax
    dpatches to use their Debian equivalents; remaining changes:
    - Run aclocal; build-dep on automake1.9.
    - Add and install kdump init script and initramfs snippet; depend on
      initramfs-tools and call the update-initramfs trigger.  Also call
      update-grup after update-initramfs trigger.
    - Default to not kexecing a kernel on boot in the automatically generated
      conffile; also disable this on upgrades from older versions.
    - Fix architecture detection on ARM, cherry-picked from upstream.
  * Build-dep on automake instead of automake1.9.

 -- Loïc Minier <loic.minier@ubuntu.com>  Mon, 08 Feb 2010 10:53:24 +0100

kexec-tools (1:2.0.1-1) unstable; urgency=low

  * New upstream version
  * Honor dpkg-preconfigure, remove /etc/default/kexec from deb package and
    remove /etc/default/kexec on package purge (closes: Bug#551919)

 -- Khalid Aziz <khalid@debian.org>  Tue, 24 Nov 2009 08:55:05 -0700

kexec-tools (1:2.0.0-2) unstable; urgency=low

  * Fixed configure script failure (closes: Bug#543081)
  * Added debian/README.source

 -- Khalid Aziz <khalid@debian.org>  Thu, 10 Sep 2009 09:34:58 -0600

kexec-tools (1:2.0.0-1) unstable; urgency=low

  * New upstream version 
  * Added note about call to shutdown by kexec -e. Also added a README.debian
    to explain automatic enablement of kexec (closes: Bug#501847)
  * Added japanese translation (closes: Bug#512870)
  * Added swedish translation (closes: Bug#503604)

 -- Khalid Aziz <khalid@debian.org>  Wed, 15 Apr 2009 16:41:45 -0600

kexec-tools (1:2.0.1-0ubuntu4) lucid; urgency=low

  * New dpatch, arm-getpagesize-unistd, cherry pick from upstream "arm:
    Include unistd.h for getpagesize()"
    c986de289120d449bf4d94c46c676566ccfd4202 to fix build issue on armel
    breaking the binaries.

 -- Loïc Minier <loic.minier@ubuntu.com>  Sun, 07 Feb 2010 22:16:39 +0100

kexec-tools (1:2.0.1-0ubuntu3) lucid; urgency=low

  * New dpatch, arm-fix-architecture-detection, cherry-pick second hunk of
    upstream commit "arm: fix architecture detection"
    5545216da4360d6494cc7ba574e04620a826a332.  Fixes support for arm* utsnames
    in particular armv7l.

 -- Loïc Minier <loic.minier@ubuntu.com>  Sun, 07 Feb 2010 21:52:30 +0100

kexec-tools (1:2.0.1-0ubuntu2) lucid; urgency=low

  * Re-add automake1.9 build-dep since we still patch configure.ac and this
    triggers an autoreconf.  (Upstream doesn't use AM_MAINTAINER_MODE.)

 -- Loïc Minier <loic.minier@ubuntu.com>  Sun, 07 Feb 2010 21:25:19 +0100

kexec-tools (1:2.0.1-0ubuntu1) lucid; urgency=low

  * New upstream release.
    - Switch to non-native packaging and upstream tarball; drop automake1.9
      build-dep.  NB: This is the Debian tarball which has been repacked by
      the Debian maintainer, but the contents are identical to the upstream
      tarball.  Picking the Debian tarball should make it easier to resync
      with Debian if we stick with 2.0.1 for a while.
    - Drop arm_build dpatch, fixed differently upstream.

 -- Loïc Minier <loic.minier@ubuntu.com>  Sun, 07 Feb 2010 20:39:48 +0100

kexec-tools (20090000-2.0.0ubuntu12) karmic; urgency=low

  * debian/patches/configure_syntax.dpatch: Put semicolons before 'fi', or
    else configure breaks.

 -- Colin Watson <cjwatson@ubuntu.com>  Wed, 07 Oct 2009 00:15:18 +0100

kexec-tools (20090000-2.0.0ubuntu11) karmic; urgency=low

  * Don't call db_stop in postinst as update-grub calls into debconf; thanks
    Colin Watson; LP: #400397.

 -- Loïc Minier <loic.minier@ubuntu.com>  Thu, 16 Jul 2009 23:05:51 +0200

kexec-tools (20090000-2.0.0ubuntu10) karmic; urgency=low

  * debian/kexec-tools.postinst:
    - run update-grub explicitely instead of using the trigger,
      grub2 does not have one (see debian #481542)

 -- Michael Vogt <michael.vogt@ubuntu.com>  Thu, 16 Jul 2009 10:42:03 +0200

kexec-tools (20090000-2.0.0ubuntu9) karmic; urgency=low

  * debian/kdump.init.d:
    - generate crash file from vmcore on first boot automatically

 -- Michael Vogt <michael.vogt@ubuntu.com>  Tue, 23 Jun 2009 10:59:14 +0200

kexec-tools (20090000-2.0.0ubuntu8) karmic; urgency=low

  * debian/kdump.initramfs:
    - use ELF format for the vmcore file. "crash" did not produce
      a backtrace with the kdump-compressed format

 -- Michael Vogt <michael.vogt@ubuntu.com>  Mon, 22 Jun 2009 17:23:45 +0200

kexec-tools (20090000-2.0.0ubuntu7) karmic; urgency=low

  * debian/kdump.initramfs:
    - dump the kernel crash info to /var/crash/vmcore-$KVER

 -- Michael Vogt <michael.vogt@ubuntu.com>  Mon, 22 Jun 2009 15:42:24 +0200

kexec-tools (20090000-2.0.0ubuntu6) karmic; urgency=low

  * debian/kexec-tools.template
    - set "kexec-tools/load_kexec" to "false" by default
  * debian/kexec-tools.postinst: 
    - trigger update-grub and update-initramfstools to ensure
      the kdump functionality is availabe on next reboot

 -- Michael Vogt <michael.vogt@ubuntu.com>  Mon, 22 Jun 2009 14:40:18 +0200

kexec-tools (20090000-2.0.0ubuntu5) karmic; urgency=low

  * debian policy forbids dpkg conffile handling and maintainer script
    configuration in the same package as this leads to inconsistant behaviour
    between apt-get install and dpkg -i installs of the same package.  Switch
    wholy to the maintainer script.  LP: #368745


=== debian/control ===
Source: kexec-tools
Section: admin
Priority: optional
Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Khalid Aziz <khalid@debian.org>
Build-Depends: debhelper (>= 7.0.0), dpatch, autoconf, gnu-efi (>=3.0a-4)[ia64], libz-dev[ia64], po-debconf, automake
Standards-Version: 3.8.3

Package: kexec-tools
Architecture: i386 amd64 ppc64 powerpc ia64 s390 arm armel
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf, initramfs-tools
Description: kexec tool for kexec reboots
 This tool is used to load a kernel in memory and reboot into the kernel
 loaded in memory using the kexec system call.

## kexec-tools 2.0.1-2ubuntu1-1drbl

=== debian/changelog ===
kexec-tools (1:2.0.1-2ubuntu1-1drbl) maverick; urgency=low

  * Comment the line "set -e" in the postrun to avoid live-helper failure.

 -- Steven Shiau <steven@nchc.org.tw>  Thu, 22 Jul 2010 10:21:45 +0800

kexec-tools (1:2.0.1-2ubuntu1) maverick; urgency=low

  * Drop debian/commit-templates/patch, unused.
  * Drop upgrade snippet for versions older than the lucid one.
  * Merge with Debian.
    - Drop dpatch arm-fix-architecture-detection, included in Debian as
      arm_arch dpatch.
    - Remaining changes:
      + Run aclocal during build; build-dep on automake1.9.
      + Add and install kdump init script and initramfs snippet; depend on
        initramfs-tools and call the update-initramfs trigger.  Also call
        update-grub after update-initramfs trigger.
      + Default to not kexecing a kernel on boot in the automatically
        generated conffile.
      + Add arm-higher-initrd-load-addr dpatch to bump initrd load offset from
        0x800000 to 0x8000000 since our kernels are so big that they overwrite
        the initrd when they uncompress; fixes kexec initrd support on all ARM
        Ubuntu kernels; LP #568283.

 -- Loïc Minier <loic.minier@ubuntu.com>  Sat, 22 May 2010 22:13:09 +0200

kexec-tools (1:2.0.1-2) unstable; urgency=low

  * Fixed kernel load failure on "armv5tel" architecture (closes: Bug#564648)
  * Added a script, codreboot, to force a cold reboot (closes: Bug#519950)
  * Added dependency dependency upon local filesystem to ensure filesystem
    containing kexec image is not unmounted before kexec-load runs 
    (closes: Bug#578126)

 -- Khalid Aziz <khalid@debian.org>  Thu, 22 Apr 2010 16:03:31 -0600

kexec-tools (1:2.0.1-1ubuntu3) lucid; urgency=low

  * New dpatch, arm-higher-initrd-load-addr, bump initrd load offset from
    0x800000 to 0x8000000 since our kernels are so big that they overwrite the
    initrd when they uncompress; fixes kexec initrd support on all ARM Ubuntu
    kernels; LP: #568283.

 -- Loïc Minier <loic.minier@ubuntu.com>  Thu, 22 Apr 2010 14:06:08 +0200

kexecc-tools (1:2.0.1-1) unstable; urgency=low

  * New upstream version
  * Honor dpkg-preconfigure, remove /etc/default/kexec from deb package and
    remove /etc/default/kexec on package purge (closes: Bug#551919)

 -- Khalid Aziz <khalid@debian.org>  Tue, 24 Nov 2009 08:55:05 -0700

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Core Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Khalid Aziz <khalid@debian.org>
 Build-Depends: debhelper (>= 7.0.0), dpatch, autoconf, gnu-efi (>=3.0a-4)[ia64], libz-dev[ia64], po-debconf, automake
-Standards-Version: 3.8.3
+Standards-Version: 3.8.4
 
 Package: kexec-tools
 Architecture: i386 amd64 ppc64 powerpc ia64 s390 arm armel

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpatch/dpatch.make


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

configure: patch configure-stamp
configure-stamp: 
	dh_testdir
	# Add here commands to configure the package.
	aclocal -I config
	autoheader
	autoconf
	./configure --prefix=/usr --sbindir=/sbin --mandir=/usr/share/man --datadir=/usr/share

	touch configure-stamp


build: patch build-stamp

build-stamp: configure-stamp 
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch build-stamp

clean: tidy unpatch

tidy: patch configure-stamp 
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp 
	rm -fr tmp-source

	# Add here commands to clean up after the build process.
	$(MAKE) dist-clean

	dh_clean 
	debconf-updatepo

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install DESTDIR=$(CURDIR)/debian/kexec-tools
	install -D -m755 debian/kdump.initramfs \
		debian/kexec-tools/usr/share/initramfs-tools/scripts/init-bottom/0_kdump
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	[ ! -f $(CURDIR)/debian/kexec-tools/usr/lib/kexec-tools-testing/kexec_test.static ] || strip $(CURDIR)/debian/kexec-tools/usr/lib/kexec-tools-testing/kexec_test.static
endif


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installdebconf
	dh_installinit --no-start -r --name=kexec -- start 85 6 .
	dh_installinit --no-start -r --name=kexec-load -- stop 18 6 .
	dh_installinit --no-start -r --name=kdump -- start 00 2 .
	dh_installexamples
	dh_lintian
	dh_install
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## kexec-tools 2.0.1.git

=== kexec/Makefile ===
--- 
+++ 
@@ -22,6 +22,8 @@
 KEXEC_SRCS += kexec/crashdump.c
 KEXEC_SRCS += kexec/crashdump-xen.c
 KEXEC_SRCS += kexec/phys_arch.c
+KEXEC_SRCS += kexec/lzma.c
+KEXEC_SRCS += kexec/zlib.c
 
 KEXEC_GENERATED_SRCS += $(PURGATORY_HEX_C)
 
@@ -30,6 +32,7 @@
 	kexec/crashdump.h kexec/firmware_memmap.h		\
 	kexec/kexec-elf-boot.h					\
 	kexec/kexec-elf.h kexec/kexec-sha256.h			\
+	kexec/kexec-zlib.h kexec/kexec-lzma.h			\
 	kexec/kexec-syscall.h kexec/kexec.h kexec/kexec.8
 
 $(ARCH)_PROC_IOMEM		= kexec/proc_iomem.c
@@ -42,6 +45,8 @@
 KEXEC_SRCS += $($(ARCH)_ADD_BUFFER)
 $(ARCH)_ARCH_REUSE_INITRD	= kexec/arch_reuse_initrd.c
 KEXEC_SRCS += $($(ARCH)_ARCH_REUSE_INITRD)
+$(ARCH)_ARCH_INIT		= kexec/arch_init.c
+KEXEC_SRCS += $($(ARCH)_ARCH_INIT)
 
 include $(srcdir)/kexec/arch/alpha/Makefile
 include $(srcdir)/kexec/arch/arm/Makefile

=== kexec/arch/arm/Makefile ===
#
# kexec arm (linux booting linux)
#
arm_KEXEC_SRCS=  kexec/arch/arm/kexec-elf-rel-arm.c
arm_KEXEC_SRCS+= kexec/arch/arm/kexec-zImage-arm.c
arm_KEXEC_SRCS+= kexec/arch/arm/kexec-uImage-arm.c
arm_KEXEC_SRCS+= kexec/arch/arm/kexec-arm.c

dist += kexec/arch/arm/Makefile $(arm_KEXEC_SRCS)			\
	kexec/arch/arm/kexec-arm.h					\
	kexec/arch/arm/include/arch/options.h

=== kexec/arch/mips/Makefile ===
#
# kexec mips (linux booting linux)
#
mips_KEXEC_SRCS =  kexec/arch/mips/kexec-mips.c
mips_KEXEC_SRCS += kexec/arch/mips/kexec-elf-mips.c
mips_KEXEC_SRCS += kexec/arch/mips/kexec-elf-rel-mips.c
mips_KEXEC_SRCS += kexec/arch/mips/crashdump-mips.c

mips_ADD_BUFFER =
mips_ADD_SEGMENT =
mips_VIRT_TO_PHYS =

dist += kexec/arch/mips/Makefile $(mips_KEXEC_SRCS)			\
	kexec/arch/mips/kexec-mips.h					\
	kexec/arch/mips/crashdump-mips.h				\
	kexec/arch/mips/include/arch/options.h

CFLAGS +=-Wall -Werror

=== kexec/arch/sh/Makefile ===
#
# kexec sh (linux booting linux)
#
sh_KEXEC_SRCS += kexec/arch/sh/kexec-sh.c
sh_KEXEC_SRCS += kexec/arch/sh/kexec-uImage-sh.c
sh_KEXEC_SRCS += kexec/arch/sh/kexec-zImage-sh.c
sh_KEXEC_SRCS += kexec/arch/sh/kexec-netbsd-sh.c
sh_KEXEC_SRCS += kexec/arch/sh/kexec-elf-sh.c
sh_KEXEC_SRCS += kexec/arch/sh/kexec-elf-rel-sh.c
sh_KEXEC_SRCS += kexec/arch/sh/netbsd_booter.S
sh_KEXEC_SRCS += kexec/arch/sh/crashdump-sh.c

sh_ADD_BUFFER =
sh_ADD_SEGMENT =
sh_VIRT_TO_PHYS =

dist += kexec/arch/sh/Makefile $(sh_KEXEC_SRCS)				\
	kexec/arch/sh/kexec-sh.h					\
	kexec/arch/sh/crashdump-sh.h					\
	kexec/arch/sh/include/arch/options.h

## kexec-tools 2.0.2

=== kexec/arch/s390/Makefile ===
#
# kexec s390 (linux booting linux)
#
s390_KEXEC_SRCS =  kexec/arch/s390/kexec-s390.c
s390_KEXEC_SRCS += kexec/arch/s390/kexec-image.c
s390_KEXEC_SRCS += kexec/arch/s390/kexec-elf-rel-s390.c

dist += kexec/arch/s390/Makefile $(s390_KEXEC_SRCS)			\
	kexec/arch/s390/kexec-s390.h					\
	kexec/arch/s390/include/arch/options.h

=== purgatory/arch/ppc64/Makefile ===
#
# Purgatory ppc64
#

ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/v2wrap.S
ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/hvCall.S
ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/purgatory-ppc64.c
ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/console-ppc64.c
ppc64_PURGATORY_SRCS += purgatory/arch/ppc64/crashdump_backup.c

ppc64_PURGATORY_EXTRA_CFLAGS += -m64 -mcall-aixdesc
ppc64_PURGATORY_EXTRA_ASFLAGS += -m64 -mcall-aixdesc
ppc64_PURGATORY_EXTRA_LDFLAGS += -melf64ppc

dist += purgatory/arch/ppc64/Makefile $(ppc64_PURGATORY_SRCS)		\
	purgatory/arch/ppc64/hvCall.h					\
	purgatory/arch/ppc64/purgatory-ppc64.h

=== purgatory/arch/x86_64/Makefile ===
#
# Purgatory x86_64
#

x86_64_PURGATORY_SRCS_native = purgatory/arch/x86_64/entry64-32.S
x86_64_PURGATORY_SRCS_native += purgatory/arch/x86_64/entry64.S
x86_64_PURGATORY_SRCS_native += purgatory/arch/x86_64/setup-x86_64.S
x86_64_PURGATORY_SRCS_native += purgatory/arch/x86_64/stack.S
x86_64_PURGATORY_SRCS_native += purgatory/arch/x86_64/purgatory-x86_64.c

x86_64_PURGATORY_SRCS += $(x86_64_PURGATORY_SRCS_native)

dist += purgatory/arch/x86_64/Makefile $(x86_64_PURGATORY_SRCS_native) 	\
	purgatory/arch/x86_64/include/arch/io.h				\
	purgatory/arch/x86_64/include/arch/debug.h			\
	purgatory/arch/x86_64/purgatory-x86_64.h

# Don't add sources in i386/ to dist, as i386/Makefile adds them
x86_64_PURGATORY_SRCS +=  purgatory/arch/i386/entry32-16.S
x86_64_PURGATORY_SRCS += purgatory/arch/i386/entry32-16-debug.S
x86_64_PURGATORY_SRCS += purgatory/arch/i386/crashdump_backup.c
x86_64_PURGATORY_SRCS += purgatory/arch/i386/console-x86.c
x86_64_PURGATORY_SRCS += purgatory/arch/i386/vga.c
x86_64_PURGATORY_SRCS += purgatory/arch/i386/pic.c

## kexec-tools 2.0.3

=== vmcore-dmesg/Makefile ===
#
# vmcore-dmesg (reading demsg from vmcore)
#

VMCORE_DMESG_SRCS:= vmcore-dmesg/vmcore-dmesg.c

VMCORE_DMESG_OBJS = $(call objify, $(VMCORE_DMESG_SRCS))
VMCORE_DMESG_DEPS = $(call depify, $(VMCORE_DMESG_OBJS))

VMCORE_DMESG = $(SBINDIR)/vmcore-dmesg
VMCORE_DMESG_MANPAGE = $(MANDIR)/man8/vmcore-dmesg.8

dist += vmcore-dmesg/Makefile $(VMCORE_DMESG_SRCS) vmcore-dmesg/vmcore-dmesg.8
clean += $(VMCORE_DMESG_OBJS) $(VMCORE_DMESG_DEPS) $(VMCORE_DMESG) $(VMCORE_DMESG_MANPAGE)

-include $(VMCORE_DMESG_DEPS)

$(VMCORE_DMESG): $(VMCORE_DMESG_OBJS)
	@$(MKDIR) -p $(@D)
	$(LINK.o) -o $@ $^ $(CFLAGS)

$(VMCORE_DMESG_MANPAGE): vmcore-dmesg/vmcore-dmesg.8
	$(MKDIR) -p     $(MANDIR)/man8
	cp vmcore-dmesg/vmcore-dmesg.8 $(VMCORE_DMESG_MANPAGE)
echo::
	@echo "VMCORE_DMESG_SRCS $(VMCORE_DMESG_SRCS)"
	@echo "VMCORE_DMESG_DEPS $(VMCORE_DMESG_DEPS)"
	@echo "VMCORE_DMESG_OBJS $(VMCORE_DMESG_OBJS)"

=== debian/changelog ===
kexec-tools (1:2.0.3-1+deb7u1) stable; urgency=low

  * Fixed the "kexec -p" failure with kernel versions of the form 
    x.y. This is the same bug as Bug#708034 that was fixed in jessie.
    (closes: Bug#722285)

 -- Khalid Aziz <khalid@debian.org>  Tue, 10 Dec 2013 10:13:58 -0700

kexec-tools (1:2.0.3-1) unstable; urgency=low

  * New upstream release
  * Switched to dpkg-source 3.0 (quilt) format
  * Updated kexec and coldreboot man pages (closes: Bug#653197)
  * Added armhf architecture (closes: Bug#645652)

 -- Khalid Aziz <khalid@debian.org>  Tue, 31 Jan 2012 09:11:31 -0700

kexec-tools (1:2.0.2-3) unstable; urgency=low

  * Added check for link_in_boot in kernel-img.conf and update kexec
    kernel and initrd locations accordingly in kexec config file 
    (closes: Bug#577064)
  * Added a check for /boot/grub directory before asking if kexec should use
    grub config (Closes: Bug#643306)
  * Added to SH4 to supported arch and changed arch for udeb to list of 
    supported Linux platforms (closes: Bug#600778)
  * Corrected the malformed patch update_kexec_manpage.dpatch
  * Added build-arch and build-indep targets to debian/rules
  * Debconf templates and debian/control reviewed by the debian-l10n-
    english team as part of the Smith review project. Closes: #639226, #636780
  * [Debconf translation updates]
  * Slovak (Slavko).  Closes: #639305
  * Russian (Yuri Kozlov).  Closes: #637753
  * Swedish (Martin Bagge / brother).  Closes: #640049
  * French (Steve Petruzzello).  Closes: #640092
  * Czech (Miroslav Kure).  Closes: #640218
  * Danish (Joe Hansen).  Closes: #640408
  * Portuguese (Rui Branco).  Closes: #640858
  * Dutch; (Jeroen Schot).  Closes: #640989
  * Spanish; (Camaleón).  Closes: #640994
  * German (Helge Kreutzmann).  Closes: #641143

 -- Khalid Aziz <khalid@debian.org>  Tue, 11 Oct 2011 10:56:59 -0600

kexec-tools (1:2.0.2-2) unstable; urgency=low

  * Fixed the problem with --no-undefined option being used for gcc. 
    Applied Matthias's patch (closes: Bug#610517, Bug#624897) 
  * Replaced copyright info in debian/copyright with list of authors
    and ensured link to license pionts to GPLv2 (closes: Bug#485679)
  * Updated PATH in init scripts to make sure /sbin and /bin are searched 
    before other paths (closes: Bug#581219)
  * Corrected kexec man page to not say shutdown is called on kexec -e
    (closes: Bug#609462)
  * Added option to use grub configuration to load kernel (close: Bug#525356)

 -- Khalid Aziz <khalid@debian.org>  Sun, 31 Jul 2011 14:30:31 -0600

kexec-tools (1:2.0.2-1) unstable; urgency=low

  * New upstream release (closes: Bug#623814)
  * Updated watch file (closes: Bug#623813)
  * Updated URL in copyright file
  * Updated linitian overrides file to match path name for new lintian
  * Added source/lintian-overrides file to override innocuous lintian errors

 -- Khalid Aziz <khalid@debian.org>  Thu, 28 Apr 2011 13:06:41 -0600

kexec-tools (1:2.0.1-4) unstable; urgency=low

  * Fix pending l10n issues. Debconf translations:
    - Spanish (Camaleón).  Closes: #583538
    - Danish (Joe Hansen).  Closes: #599859
    - Italian (Vincenzo Campanella).  Closes: #600218

 -- Khalid Aziz <khalid@debian.org>  Mon, 18 Oct 2010 12:01:47 -0600

kexec-tools (1:2.0.1-3) unstable; urgency=low

  * Added support for building udeb (closes: Bug#591441) 
  * Updated standards version to 3.9.1

 -- Khalid Aziz <khalid@debian.org>  Mon, 09 Aug 2010 14:41:14 -0600

=== debian/control ===
Source: kexec-tools
Section: admin
Homepage: http://kernel.org/pub/linux/utils/kernel/kexec/
Priority: optional
Maintainer: Khalid Aziz <khalid@debian.org>
Build-Depends: debhelper (>= 7.0.0), autoconf, gnu-efi (>=3.0a-4)[ia64], libz-dev[ia64], po-debconf
Standards-Version: 3.9.2

Package: kexec-tools
Architecture: i386 amd64 ppc64 powerpc ia64 s390 arm armel armhf sh4
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf
Description: tools to support fast kexec reboots
 This package provides tools to load a kernel into memory and then
 "reboot" directly into that kernel using the kexec system call,
 bypassing the normal boot process.

Package: kexec-tools-udeb
Section: debian-installer
Architecture: i386 amd64 ppc64 powerpc ia64 s390 arm armel armhf sh4
XC-Package-Type: udeb
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: tools to support fast kexec reboots (udeb)

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,6 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-include /usr/share/dpatch/dpatch.make
 
 
 CFLAGS = -Wall -g
@@ -20,11 +19,10 @@
 	CFLAGS += -O2
 endif
 
-configure: patch configure-stamp
+configure: configure-stamp
 configure-stamp: 
 	dh_testdir
 	# Add here commands to configure the package.
-	aclocal -I config
 	autoheader
 	autoconf
 	./configure --prefix=/usr --sbindir=/sbin --mandir=/usr/share/man --datadir=/usr/share
@@ -32,7 +30,9 @@
 	touch configure-stamp
 
 
-build: patch build-stamp
+build: build-arch build-indep
+build-arch: build-stamp
+build-indep: build-stamp
 
 build-stamp: configure-stamp 
 	dh_testdir
@@ -42,9 +42,9 @@
 
 	touch build-stamp
 
-clean: tidy unpatch
+clean: tidy 
 
-tidy: patch configure-stamp 
+tidy: configure-stamp 
 	dh_testdir
 	dh_testroot
 	rm -f build-stamp configure-stamp 
@@ -64,12 +64,11 @@
 
 	# Add here commands to install the package into debian/tmp.
 	$(MAKE) install DESTDIR=$(CURDIR)/debian/kexec-tools
-	install -D -m755 debian/kdump.initramfs \
-		debian/kexec-tools/usr/share/initramfs-tools/scripts/init-bottom/0_kdump
 ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
 	[ ! -f $(CURDIR)/debian/kexec-tools/usr/lib/kexec-tools-testing/kexec_test.static ] || strip $(CURDIR)/debian/kexec-tools/usr/lib/kexec-tools-testing/kexec_test.static
 endif
 
+	install -D -m 0755 debian/kexec-tools/sbin/kexec debian/kexec-tools-udeb/sbin/kexec
 
 # Build architecture-independent files here.
 binary-indep: build install
@@ -84,7 +83,6 @@
 	dh_installdebconf
 	dh_installinit --no-start -r --name=kexec -- start 85 6 .
 	dh_installinit --no-start -r --name=kexec-load -- stop 18 6 .
-	dh_installinit --no-start -r --name=kdump -- start 00 2 .
 	dh_installexamples
 	dh_lintian
 	dh_install

=== debian/watch ===
version=3
http://kernel.org/pub/linux/utils/kernel/kexec/kexec-tools-(.*)\.tar\.gz
